<?php
  
class Concordance extends Controller {
  //
  // controles dictionary entries
  // 
  var $name = "concordance";
  var $sqlMax = 100;

  function buildConcordanceNavigation($query, $offset, $total) {
    //
    // build a navigation toolbar
    //
    if ($offset == NULL) {
      $offset = 0;
    }
    $last = (int) ($total / $this->sqlMax);
    $begin = $offset * $this->sqlMax + 1;
    $end = ($offset + 1) * $this->sqlMax;
    if ($end > $total) {
      $end = $total;
    }
    if ($offset > 1) {
      $this->buildNavigationLink("&lt;&lt; Início", $query, 0);
    }
    if ($offset > 0) {
      $this->buildNavigationLink("&lt; Voltar", $query, $offset - 1);
    }
    print("$begin a $end de $total\n");
    if ($offset < $last) {
      $this->buildNavigationLink("Avançar &gt;", $query, $offset + 1);
    }
    if ($offset < $last - 1) {
      $this->buildNavigationLink("Fim &gt;&gt;", $query, $last);
    }

  }

  function buildNavigationLink($text, $query, $offset) {
    //
    // build a navigation link
    //
    $link = $_SERVER["PHP_SELF"]; 
    print("<a href=\"$link?query=$query&offset=$offset\">$text</a>\n");
  }

  function search($query, $offset) {
    //
    // retrieves concordance for a given query
    //
    $tokens = split(" ", $query);
    $totalTokens = count($tokens);
    $from = "";
    $fields = "";
    $where = "";
    $results = null;
    $shift = 10;
    if ($offset==NULL) {
      $offset=0;
    }
    for ($i=0; $i<$totalTokens; $i++) {
      $fields .= ($i==0? "": ", ") . "c{$i}.word";
      $from .= ($i==0? "": ", ") . "concordances as c{$i}";
      $j = $i-1;
      $where .= ($i==0? "": " and c{$i}.id=c{$j}.id+1 and ") 
        . " c{$i}.word='{$tokens[$i]}'"; 
    }
    $offset = $this->normalizeOffset($offset);
    $command = "select sql_calc_found_rows c0.id from $from where $where"
      . " limit {$this->sqlMax} offset $offset";
    $ids = mysql_query($command);
    $total = mysql_fetch_array(mysql_query("SELECT FOUND_ROWS() as total"));
    $results["total"] = $total["total"];
    if ($results["total"] == 0) {
      return null;
    }
    $i = 0;
    while ($id = mysql_fetch_array($ids)) {
      $lower = $id["id"] - $shift;
      $upper = $id["id"] + $totalWords + $shift;
      $command = "select * from concordances where id between $lower and $upper";
      $concordance = mysql_query($command);
      $results["concordances"][$i]["begin"] = "";
      $results["concordances"][$i]["middle"] = "";
      $results["concordances"][$i]["end"] = "";
      $j = 0;
      while ($word = mysql_fetch_array($concordance)) {
        $aux =  $word["word"] . ($word["complement"]? $word["complement"]: " ");
        if ($j < $shift) {
          $results["concordances"][$i]["begin"] .= $aux;
        } else if ($j < $shift + $totalTokens) {
          $results["concordances"][$i]["middle"] .= $aux;
        } else {
          $results["concordances"][$i]["end"] .= $aux;
        }
        $j++;
      }
      $aux = $results["concordances"][$i]["begin"];
      if (strlen($aux)>50) {
        $aux = $this->utf8_substr($aux, -50);
        $results["concordances"][$i]["begin"] = $aux;
      }
      $aux = $results["concordances"][$i]["end"];
      if (strlen($aux)>50) {
        $aux = $this->utf8_substr($aux, 0, 50);
        $results["concordances"][$i]["end"] = $aux;
      }
      $i++;
    }
    return $results;
  }

  function utf8_substr($str,$start) {
    //
    // subtrs compliant with unicode
    //
    preg_match_all("/./u", $str, $ar);
    if(func_num_args() >= 3) {
      $end = func_get_arg(2);
      return join("",array_slice($ar[0],$start,$end));
    } else {
      return join("",array_slice($ar[0],$start));
    }
  } 

}

?>
