<?php
require("table.php");

class Database {
  //
  // stores tables 
  // 
  var $name;
  var $humanName;
  var $records;
  var $totalTables = 0;
  var $tables = array();
  var $tablesByName = array();
  
  function __construct($name, $humanName) {
    //
    // create a new database
    //
    $this->name = $name;
    $this->humanName = $humanName;
  }
  
  function addTable($name, $humanName) {
    //
    // add a new table in this database
    //
    $table = new Table($name, $humanName);
    $this->tables[$this->totalTables++] = $table;
    $this->tablesByName[$name] = $table;
  }

  function buildCrud() {
    //
    // build an insert, delete or update command
    //
    $fieldName = "";
    $fields = "";
    $filedsValues = "";
    $first = true;
    $sql = "";
    $values = "";
    $record = func_get_arg(0);
    $table = $record["table"];
    $id = $record[func_get_arg(1)];
    // deleting
    if ($record["is_deleted"] == "true" && $id != "-1") {
      $sql = "delete from $table where id=$id";
      return $sql;
    }
    // inserting or updating
    for($i = 2; $i < func_num_args(); $i++) {
      $fieldName = func_get_arg($i); 
      if ($record[$fieldName] == "null") {
        continue;
      }
      if ($id == "-1") {
        if (! $first) {
          $fields .= ", ";
          $values .= ", ";
        }
        $fields .=  $fieldName;
        $values .= "'" . addslashes($record[$fieldName]) . "'";
      } else {
        if (! $first) {
          $fieldsValues .= ", ";
        }
        $fieldsValues .= $fieldName . "='" . 
          addslashes($record[$fieldName]) . "'";  
      }
      $first = false;    
    }
    if ($id == "-1") {
      $sql = "insert into $table ($fields) values ($values);"; 
    } else {
      $sql = "update $table set $fieldsValues where id=$id;";
    }
    return $sql;
  }
  
  function getLastTable() {
    //
    // return the last table added in this database
    //
    if (! $this->tables) {
      return NULL;
    }
    return ($this->tables[$this->totalTables - 1]);
  }
  
  function setRecords($encoded) {
    //
    // populate records array through an encoded records string
    //
    $curretField = 0; // current field
    $currentRecord = -1; // current record
    $this->records = array();
    while ($encoded["f$curretField"]) {
      $field = $encoded["f$curretField"];
      $value = $encoded["v$curretField"];
      if ($field == "table") {
        $currentRecord++;
      }
      if ($currentRecord >= 0) {
        $this->records[$currentRecord][$field] = $value;
      }
      $curretField++;
    }
    if ($currentRecord >= 0) {
      return true;
    }
    return false;
  }

}

?>
