<?php
  
class Entry extends Controller {
  //
  // controles dictionary entries
  // 
  var $name = "Entry";
  var $sqlTable = "entries";
  
  function _list($offset, $parent) {
    //
    // load data for page list 
    //
    $builder = $this->procorph->formBuilder; 
    $list["add_button"] = ($this->procorph->userLevel >= 2) ? true: false;
    $list["entries"] = NULL;
    if ($parent == NULL) {
      $entries = $this->getEntries($offset);
    } else {
      $entries = $this->getSubentries($parent);
    }
    while ($entry = mysql_fetch_array($entries)) {
      // css
      $entry["css"] = ($i % 2 == 1) ? "odd": "even";
      // editable
      if ($this->procorph->userLevel >= 3 || ($this->procorph->userLevel == 2 
          && $entry["user_id"]==$this->procorph->user["id"])) {
        $entry["editable"] = true;
      } else {
        $entry["editable"] = false;
      }
      // spellings
      $spellings = $this->getSpellings($entry["id"]);
      $entry["spellings"] = "";
      while ($spelling = mysql_fetch_array($spellings)) {
        $entry["spellings"] .= ($entry["spellings"] != "") ? ", ": "";
        $entry["spellings"] .= $spelling["name"];
      }
      // relateds
      $relateds = $this->getRelateds($entry["id"]);
      $entry["relateds"] = "";
      while ($related = mysql_fetch_array($relateds)) {
        $entry["relateds"] .= ($entry["relateds"] != "") ? ", ": "";
        $entry["relateds"] .= $related["name"];
      }
      $builder->sanitizeHtml($entry);
      // finishing
      $list["entries"][$i] = $entry;
      $i++;
    }
    return $list;
  }
  
  function _view($id) {
    //
    // load data for page view
    //
    $view = NULL;
    $entry = $this->get($id);
    $builder = $this->procorph->formBuilder; 
    // entry
    if (! $entry) {
      return NULL;
    }
    // spellings
    $first = true;
    $spellings = $this->getSpellings($id);
    $entry["spellings"] = NULL;
    $builder->sanitizeHtml($entry);
    if(mysql_num_rows($spellings) > 0) {
      while ($spelling = mysql_fetch_array($spellings)) {
        if ($first) {
          $entry["spellings"] = $spelling["name"];
          $first = false;
        } else {
          $entry["spellings"] .= ", " . $spelling["name"];
        }
      }
    }
    // definitions
    $definitions = $this->getDefinitions($id);
    $i = 1;
    while ($definition = mysql_fetch_array($definitions)) {
      $builder->sanitizeHtml($definition);
      $definition["number"] = $i;
      $definition["text_details"] = 
        $this->getTextDetails($definition["text_id"]);
      $entry["definitions"][$i] = $definition; 
      $i++;
    }
    // relateds
    $first = true;
    $relateds = $this->getRelateds($id);
    while ($related = mysql_fetch_array($relateds)) {
      $builder->sanitizeHtml($related);
      if ($first) {
        $entry["relateds"] = $related["name"];
        $first = false;
      } else {
        $entry["relateds"] .= ", " . $related["name"];
      }
    }
    // notes
    $i = 0;
    $notes = $this->getNotes($id);
    while ($note = mysql_fetch_array($notes)) {
      $entry["notes"][$i++] = $note;
    }
    // first_example
    if ($entry["first_example"]) {
      $entry["text_details"] = $this->getTextDetails($entry["text_id"]);
    }
    // sub-entries
    $i = 0;
    if ($entry["parent"] == NULL) {
      $subentries = $this->getSubentries($entry["id"]);
      while ($subentry = mysql_fetch_array($subentries)) {
        $subentry_view = $this->_view($subentry["id"]);
        $subentry_view["entry"]["number"] = $i;
        $view["subentries"][$i++] = $subentry_view['entry']; 
      }
    }
    // finishing
    $view['entry'] = $entry;
    return $view;
  }
  
  function checkPermissions($entry_id) {
    //
    // checks if user can edit/delete an entry
    //
    $user_level = $this->procorph->userLevel;
    $user_id = $this->procorph->user["id"];
    if (!$entry_id) {
      $entry_id = "-1";
    }
    if ($user_level < 2) {
      return false;
    }
    if ($user_level < 3 && $entry_id != -1) {
      $entry = $this->get($entry_id);
      if ($entry["user_id"] !=  $user_id) {
        return false;
      }
    }
    return true;
  }

  function count() {
    //
    // count total of records
    //
    $command = "select count(*) from entries where parent is null";
    $record = mysql_fetch_array(mysql_query($command));
    return $record[0]; 
  }
  
  function countChildren($table, $id) {
    //
    // count the number of childs of an entry
    //
    if ($this->procorph->userLevel < 1) {
      return "";
    }
    $select = "select count(*) from $table where entry_id=$id";
    $count = mysql_fetch_array(mysql_query($select)); 
    return $count[0];
  }
  
  function delete($id, &$status) {
    //
    // delete an entry
    //
    if (! $this->checkPermissions($id)) {
      $status = "Acesso negado";
      return false;
    }
    return parent::delete($id, $status);
  }
    
  function get($id) {
    //
    // returns an record in entries database
    //
    if ($this->procorph->userLevel < 1) {
      return "";
    }
    $id = addslashes($id);
    $select = "select entries.*, users.name as user_name,"
      . " classes.name as class_name from entries, users, classes where"
      . " entries.id=$id and users.id=user_id and classes.id=class_id;";
    return mysql_fetch_array(mysql_query($select));
  }
  
  function getSubentries($parent) {
    //
    // returns All records in entries database when $parent
    //
    if ($this->procorph->userLevel < 1) {
      return "";
    }
    $command = "select entries.*, users.name as user_name,"
      . " status.name as status_name, classes.name as class_name"
      . " from entries, users, classes, status"
      . " where users.id = user_id "
      . " and status.id = status_id"
      . " and classes.id = class_id"
      . " and entries.parent = $parent"
      . " order by name";
    return mysql_query($command);
  }
  
  function getEntries($offset) {
    //
    // returns All records in entries database when $parent
    //
    if ($this->procorph->userLevel < 1) {
      return "";
    }
    $offset = $this->normalizeOffset($offset);
    $command = "select entries.*, users.name as user_name,"
      . " status.name as status_name, classes.name as class_name"
      . " from entries, users, classes, status"
      . " where users.id = user_id "
      . " and status.id = status_id"
      . " and classes.id = class_id"
      . " and entries.parent is null"
      . " order by name"
      . " limit $this->sqlMax offset $offset";
    return mysql_query($command);
  }
         
  function getClasses() {
    //
    // returns all records in table classes
    //
    if ($this->procorph->userLevel < 2) {
      return "";
    }
    $select = "select id, name from classes";
    return mysql_query($select);
  }
    
  function getDefinitions($entry_id) {
    //
    // returns all definitions for an entry
    //
    if ($this->procorph->userLevel < 1) {
      return "";
    }
    $entry_id = addslashes($entry_id);
    $select = "select * from definitions" .
      " where entry_id=$entry_id  order by order_def";
    return mysql_query($select);
  }
   
  function getNotes($entry_id) {
    //
    // returns all definitions for an entry
    //
    if ($this->procorph->userLevel < 1) {
      return "";
    }
    $entry_id = addslashes($entry_id);
    $select = "select * from notes" .
      " where entry_id=$entry_id  order by order_note";
    return mysql_query($select);
  }
  
  function getRelateds($entry_id) {
    //
    // returns all relateds entries for an entry
    //
    if ($this->procorph->userLevel < 1) {
      return "";
    }
    $entry_id = addslashes($entry_id);
    $select = "select * from relateds" .
      " where entry_id=$entry_id  order by order_related";
    return mysql_query($select);
  }
   
  function getSpellings($entry_id) {
    //
    // returns all spellings for an entry
    //
    if ($this->procorph->userLevel < 1) {
      return "";
    }
    $entry_id = addslashes($entry_id);
    $select = "select * from spellings" .
      " where entry_id=$entry_id order by order_spelling";
    return mysql_query($select);
  }
  
  function getStatus() {
    //
    // returns all records in table classes
    //
    if ($this->procorph->userLevel < 2) {
      return "";
    }
    $level = $this->procorph->userLevel;
    $select = "select id, name from status where level<=$level order by id";
    return mysql_query($select);
  }
  
  function getTextDetails($name) {
    //
    // return formated details about an text
    //
    if ($name == NULL) {
      $name = "";
    } else {
      $name = addslashes($name);
    }
    $command = "select name, title, author, creation_year"
      . " from texts where name='$name'";
    $text = mysql_fetch_array(mysql_query($command));
    if ($text) {
      return ("{$text["author"]} [<strong>{$text["creation_year"]}</strong>]."
        . " <em>{$text["title"]}</em>");
    }
    return "";
  }
  
  function getUsers() {
    //
    // returns all records in table users 
    //
    if ($this->procorph->userLevel < 3) {
      return NULL;
    }
    $select = "select users.id, users.name from users, groups"
      . " where users.group_id=groups.id and groups.level>=2"
      . " order by users.name";
    return mysql_query($select);
  }

  function save(&$status) {
    //
    // builds an insert or update sql and save data
    //
    $commands = array();
    $entryId = NULL;
    $error = "Erro processando parâmetros";
    $sqlError = 0;
    $i=0;
    $record = NULL;
    $model = $this->procorph->database;
    $model->setRecords($_POST);
    $builder = $this->procorph->formBuilder;
    // entries, part 1
    $record = $model->records[$i];
    if (! $record || $record["table"] != "entries") {
      return $error;
    }
    if (! $this->checkPermissions($record["id"])) {
      $status = "Acesso negado";
      return false;
    }
    // user can save entries from others?
    if ($this->procorph->userLevel < 3) {
      $record["user_id"] = $this->procorph->user["id"];
    }
    // definning creating date
    if ($record["id"] == -1) {
      $record["creation_date"] = date("Y-m-d");
    } else {
      $record["creation_date"] = "null";
    }
    // definning parent
    if ($record["parent"] == -1) {
      $record["parent"] = "null";
    }
    // converting to unicode
    $record["name"] = $builder->convertToUnicode($record["name"]);
    // inserting or updating
    $commands[$i] = $model->buildCrud($record, "id", "name", "class_id",  
      "status_id", "creation_date", "user_id", "parent");
    if (!mysql_query($commands[$i])) {
      $sqlError++;
      $entryId = "";
    } elseif ($record["id"] == -1) {
      $entryId = mysql_insert_id();
    } else {
      $entryId = $record["id"];
    }
    $i++;
    // spellings
    $order = 0;
    while ($model->records[$i]["table"] == "spellings") {
      $record = $model->records[$i];
      $record["entry_id"] = $entryId;
      if ($record["is_deleted"] != "true") {
        $order++;
      }
      $record["order_spelling"] = $order;
      $commands[$i] = $model->buildCrud($record, "id", "name", "entry_id", 
        "order_spelling");
      if (!mysql_query($commands[$i])) {
        $sqlError++;  
      }
      $i++;
    }
    // definitions
    $order = 0;
    while ($model->records[$i]["table"] == "definitions") {
      $record = $model->records[$i];
      $record["entry_id"] = $entryId;
      if ($record["is_deleted"] != "true") {
        $order++;
      }
      $record["order_def"] = $order;
      $commands[$i] = $model->buildCrud($record, "id", "description", 
        "attributes", "example", "text_id", "page", "entry_id", "order_def");
      if (!mysql_query($commands[$i])) {
        $sqlError++;  
      }
      $i++;
    }
    // relateds 
    $order = 0;
    while ($model->records[$i]["table"] == "relateds") {
      $record = $model->records[$i];
      $record["entry_id"] = $entryId;
      if ($record["is_deleted"] != "true") {
        $order++;
      }
      $record["order_related"] = $order;
      $record["name"] = $builder->convertToUnicode($record["name"]);
      $commands[$i] = $model->buildCrud($record, "id", 
        "name", "entry_id", "order_related");
      if (!mysql_query($commands[$i])) {
        $sqlError++;  
      }
      $i++;
    }
    // notes
    $order = 0;
    while ($model->records[$i]["table"] == "notes") {
      $record = $model->records[$i];
      $record["entry_id"] = $entryId;
      if ($record["is_deleted"] != "true") {
        $order++;
      }
      $record["order_note"] = $order;
      $commands[$i] = $model->buildCrud($record, "id", 
        "description", "entry_id", "order_note");
      if (!mysql_query($commands[$i])) {
        $sqlError++;  
      }
      $i++;
    }
    // entries, part 2: first sample
    $record = $model->records[$i];
    if ($record["table"] != "entries") {
      return $error;
    }
    $record["id"] = $entryId; 
    $commands[$i] = $model->buildCrud($record, "id", 
      "first_example", "text_id", "page");
    if (!mysql_query($commands[$i])) {
      $sqlError++;
    }
    //foreach($commands as $command) {
    //  $this->procorph->log($command);
    //}
    if ($sqlError == 0) {
      return true;
    } else {
      $status = "$sqlError erro(s) desconhecido(s) ao salvar";
     return false; 
    }
  }
}
?>
