<?php

class Field {
  //
  // store sql fields information and allow sql creation
  //

  var $default;
  var $humanName; 
  var $indexForeign = false;
  var $indexPrimary = false;
  var $indexRegular = false;
  var $indexSize;
  var $isAutoIncrement = false;
  var $isNull = false;
  var $key;
  var $name;
  var $ondelete;
  var $onupdate;
  var $referenceField;
  var $referenceTable;
  var $size;
  var $type;
  
  function __construct($name, $humanName, $type, $size) {
	  //
	  // creates a new field
	  //
    $this->name = $name;
    $this->humanName = $humanName;
    $this->type = $type;
    $this->size = $size;
  }
  
  function setIndexForeign($referenceTable, $referenceField, 
    $onDelete, $onUpdate) {
    //
    // set this field as an foreign key
    //
    $this->indexForeign = true;
    $this->referenceTable = $referenceTable;
    $this->referenceField = $referenceField;
    $this->onDelete = $onDelete;
    $this->onUpdate = $onUpdate;
  }
  
  function setIndexPrimary($isAutoIncrement) {
    //
    // set this field as a primary key
    //
    $this->indexPrimary = true;
    $this->isAutoIncrement = $isAutoIncrement;
  }

  function setIndexRegular($indexSize) {
    //
    // set this field as a key
    //
    $this->indexRegular = true;
    $this->indexSize = $indexSize;
  }
  
  function setNull($isNull) {
    //
    // set this field as null
    //
    $this->isNull = $isNull;
  }
  
}

?>