<?php
// helpers
require(dirname(__FILE__) . "/modelLoader.php");
require(dirname(__FILE__) . "/formBuilder.php");
require(dirname(__FILE__) . "/controller.php");
// controllers
require(dirname(__FILE__) . "/entry.php");
require(dirname(__FILE__) . "/user.php");
require(dirname(__FILE__) . "/text.php");
require(dirname(__FILE__) . "/glossary.php");
require(dirname(__FILE__) . "/concordance.php");

class Procorph {
  //
  // the main application class
  //
  var $formBuilder;
  var $connection;
  var $conf;
  var $connectionError = "";
  var $database;
  var $urlRoot;
  var $user = array();
  var $userLevel;
  // modules
  var $concordance;
  var $entry;
  var $glossary;
  var $text;
  var $userAdmin;

  function __construct() {
    //
    // defines base procorph settings
    //
    include(dirname(__FILE__) . "/conf.php");
    $this->conf = $conf;
    $this->connect();
    $modelLoader = new ModelLoader();
    $this->database = $modelLoader->database;
    $this->formBuilder = new FormBuilder($this->database);
    $this->registerModules();
  }
  
  function __destruct() {
    //
    // disconnect from mysql
    //
    if ($this->connection) {
      mysql_close($this->connection);
    }
    $this->unregisterModules;
  }
    
  function buildJson($status, $description, $redirect) {
    //
    // build a json compliant with procorph javascripts
    // 0-ok, 1-login, 2-error, 3-warning
    $json = 
      "{\n" .
      "  statusj: $status,\n" .
      "  description: \"$description\",\n" .
      "  redirect: \"$redirect\"\n" .
      "}";
    print($json);
  }

  function changePassword($old, $new, &$status) {
    //
    // changes user password
    //
    $old = addslashes($old);
    $new = addslashes($new);
    if (strlen($new) < 8) {
      $status = "Sua nova senha deve possuir no mínimo 8 caracteres!";
      return 0;
    }
    $user_id = $this->user["id"];
    $command = "select id from users where id=$user_id"
      . " and password=password('$old')";
    $result = mysql_query($command);
    if ($user = mysql_fetch_array($result)) {
      $command = "update users set password=password('$new')"
        . " where id=$user_id";
      if (mysql_query($command)) {
        $status = "Senha alterada com sucesso";
        return 1;
      } else {
        $status = "Erro indefinido ao alterar senha!";
        return 0;
      }
    }
    $status = "Senha incorreta!";
    return 0;
  }

  private function connect() {
    //
    // connect into mysql database
    //
    $this->connection = @mysql_connect("localhost", 
      $this->conf["database"]["userName"], 
      $this->conf["database"]["password"]);
    if (!$this->connection) {
      $this->connectionError = mysql_error();
      return false;
    }
    mysql_select_db("procorph", $this->connection);
    return true;
  }

  function doLogin($userName, $password, &$status) {
    //
    // authenticates an user
    //
    $result = "";
    $userName = addslashes($userName); 
    $password = addslashes($password);
    if (!$this->connection) {
      $status = "Não foi possível se conectar ao banco de dados";
      return false;
    }
    $users = mysql_query("select * from users where login='$userName'"
      . " and password=password('$password') and active=true");
    if ($user = mysql_fetch_array($users) and $user["login"] == $userName) {
      $this->user = $this->getUser($user["id"]);
      $this->userLevel = $this->user["group_level"]; 
      mysql_query("update users set last_login=now() where id=" . 
        $user["id"] . ";");
      $status = "";
      return true;
    }
    $status = "Nome de usuário ou senha inválidos!";
    sleep(5);
    return false;
  }

  function doLogout() {
    //
    // deauthenticates an user
    //
    session_start();
    unset($_SESSION['procorph']);
  }

 static function getSingleton() {
    //
    // return procorph object from section or generate an new
    //
    session_start();
    $procorph = $_SESSION['procorph']; 
    if (!$procorph ) {
      $procorph = new Procorph();
      $_SESSION["procorph"] = $procorph;
    }
    $procorph->connect();
    return $procorph; 
  }
  
  function getUser($id) {
    //
    // get information about the current logged user
    //
    $user = mysql_query("select users.*, groups.level as group_level"
      . ", groups.name as group_name"
      . " from users, groups where users.id='$id'"
      . " and users.group_id=groups.id");
    return(mysql_fetch_array($user));
  }

  function getUrlRoot($invoked) {
    //
    // return the system base url
    // must be called by root_dir scripts
    //
    $invoked = dirname($invoked);
    $invoker = dirname(realpath($_SERVER['SCRIPT_FILENAME']));
    $url = dirname($_SERVER['PHP_SELF']);
    while ($invoker != $invoked) {
      if (dirname($invoker) == $invoker) {
        break;
      }
      $invoker = dirname($invoker);
      $url = dirname($url);
    }
    $this->urlRoot = $url;
    return $this->urlRoot;
  }

  function log($message) {
    //
    // saves logging information on procorph.log
    //
    $log = fopen(dirname(__FILE__) . "/../procorph.log", "a");
    fwrite($log, "$message\n");
    fclose($log);
  }
  
  private function registerModules() {
    //
    // register modules enabled
    //
    $this->entry = new Entry();
    $this->entry->procorph = $this;
    $this->userAdmin = new User();
    $this->userAdmin->procorph = $this;
    $this->text = new Text();
    $this->text->procorph = $this;
    $this->glossary = new Glossary();
    $this->glossary->procorph = $this;
    $this->concordance = new Concordance();
    $this->glossary->concordance = $this;
  }
  
  function savePreferences(&$status) {
    //
    // save user settings
    //
    $record["table"] = "users";
    $record["id"] = $this->user["id"];
    $record["name"] = $_POST["name"];
    $record["email"] = $_POST["email"];
    $command = $this->database->buildCrud($record, "id", "name", "email");
    if (mysql_query($command)) {
      $this->user = $this->getUser($this->user["id"]);
      $status = "Informações salvas com sucesso!";
      return 1;
    } else {
      $status = "Erro desconhecido ao salvar";
      return 0;
    }
  }

  function sendMail($name, $email, $subject, $body, &$status) {
    //
    // send an e-mail to admin
    //
    if (! $email) {
      $status = "É necessário informar o seu e-mail";
      return false;
    }
    if (! $subject && $message) {
      $status = "É necessário informar o assunto da mensagem";
      return false;
    }
    $message = "Remetente: $name <$email>\nAssunto: $subject\n\n$body";
    $from = "From: Sistema ProCorpH <nobody@locahost>";
    $from .= "\nContent-Type: text/plain; charset=\"utf-8\"";
    $subject = "Mensagem enviada através do sistema ProCorpH";
    $to = $this->conf["admin"]["email"];
    if (mail($to, $subject, $message, $from)) {
      $status = "Mensagem enviada com sucesso!";
      return true;
    }
    $status = "Falha desconhecida ao enviar mensagem!";
    return false;
  }

  private function unregisterModules() {
    //
    // register modules enabled
    //
    $this->entry->procorph = NULL;
    unset($this->entry);
    $this->userAdmin->procorph = NULL;
    unset($this->userAdmin);
    $this->text->procorph = NULL;
    unset($this->text);
    $this->glossary->procorph = NULL;
    unset($this->glossary);
    $this->concordance->procorph = NULL;
    unset($this->concordance);
  }
}

?>
