# procorph.sql
# Generated automatically by MvcBuilder.
# Do not change or edit

# Grupos
create table groups (id int not null auto_increment primary key, name varchar (60) not null, index (name), level integer not null) engine=innodb default character set utf8 collate utf8_general_ci;

# Usuários
create table users (id integer not null auto_increment primary key, login varchar (30) not null, index (login), name varchar (100) not null, index (name), email varchar (100) not null, password varchar (50) not null, last_login datetime, active boolean not null, index (active), group_id integer not null, foreign key (group_id) references groups (id) on delete restrict on update restrict) engine=innodb default character set utf8 collate utf8_general_ci;

# Classes
create table classes (id int not null auto_increment primary key, name varchar (60) not null, index (name)) engine=innodb default character set utf8 collate utf8_general_ci;

# Situações
create table status (id integer not null auto_increment primary key, name varchar (60) not null, index (name), level integer not null) engine=innodb default character set utf8 collate utf8_general_ci;

# Verbetes
create table entries (id int not null auto_increment primary key, name varchar (60) not null, index (name), class_id integer not null, foreign key (class_id) references classes (id) on delete restrict on update restrict, status_id integer not null, foreign key (status_id) references status (id) on delete restrict on update restrict, creation_date date not null, first_example text not null, index (first_example(100)), text_id varchar (8) not null, page decimal (4) not null, user_id integer not null, foreign key (user_id) references users (id) on delete restrict on update restrict, parent integer, foreign key (parent) references entries (id) on delete cascade on update cascade) engine=innodb default character set utf8 collate utf8_general_ci;

# Variantes de grafia
create table spellings (id int not null auto_increment primary key, name varchar (60) not null, index (name), order_spelling integer not null, index (order_spelling), entry_id integer not null, foreign key (entry_id) references entries (id) on delete cascade on update restrict) engine=innodb default character set utf8 collate utf8_general_ci;

# Acepções
create table definitions (id int not null auto_increment primary key, description text not null, index (description(100)), attributes varhcar not null, example text not null, index (example(100)), text_id varchar (8) not null, page decimal (4) not null, order_def integer not null, index (order_def), entry_id integer not null, foreign key (entry_id) references entries (id) on delete cascade on update restrict) engine=innodb default character set utf8 collate utf8_general_ci;

# Verbetes relacionados
create table relateds (id int not null auto_increment primary key, name varchar (60) not null, index (name), order_related integer not null, index (order_related), entry_id integer not null, foreign key (entry_id) references entries (id) on delete cascade on update restrict) engine=innodb default character set utf8 collate utf8_general_ci;

# Observações
create table notes (id int not null auto_increment primary key, description text not null, index (description(100)), order_note integer not null, index (order_note), entry_id integer not null, foreign key (entry_id) references entries (id) on delete cascade on update restrict) engine=innodb default character set utf8 collate utf8_general_ci;

# Textos
create table texts (id integer not null auto_increment primary key, name varchar (8) not null, index (name), title text not null, index (title(100)), author varchar (100) not null, index (author), creation_year varchar (11) not null, index (creation_year), edition_year varchar (11) not null, index (edition_year)) engine=innodb default character set utf8 collate utf8_general_ci;

# Concordâncias
create table concordances (id int not null auto_increment primary key, word varchar (100) not null, index (word), complement text not null) engine=innodb default character set utf8 collate utf8_general_ci;

# Glossários
create table glossaries (id int not null auto_increment primary key, word1 varchar (100) not null, index (word1), word2 varchar (100) not null, index (word2), category varchar (100) not null, index (category), extras varchar (100) not null) engine=innodb default character set utf8 collate utf8_general_ci;
